/**
 *  TP 3 : Synchronisation par Smaphores Posix.
 * ------------------------------------
 *   Producteur / Consommateur simple : un producteur, un consommateur, un buffer partag, compos d'une seule case 
 * ------------------------------------
 *
**/

#include <stdio.h>           
#include <stdlib.h>           
#include <string.h>          
#include <pthread.h>
#include <semaphore.h>

sem_t  ver_plein,  ver_vide; // dclaration de deux smaphores
int variable= 0 ;

void *produire(void *arg);	// prototype de la fonction executee par le producteur
void *consommer (void *arg); // prototype de la fonction executee par le consommateur


int main(int argc, char *argv[])
{
	   int v, p error;

pthread_t th_conso, th_prod; // declaration de deux threads

/* Initialisation des smaphores */

	 v = sem_init(&ver_plein, 0, 0);
	 p = sem_init(&ver_vide, 0, 1);
	if (v == -1 || p == -1) {
	printf ("Erreur : problme lors de l'initialisation des semaphores\n");
		exit (1);
	}

		error = pthread_create(&th_conso, NULL, consommer, NULL);
		if (error !=0) printf ("erreur lors de la creation de thread consommateur \n");
		error = pthread_create(&th_prod, NULL, produire, NULL);
		if (error !=0) printf ("erreur lors de la creation de thread producteur \n");
	
//attendre la fin des threads
	 
	pthread_join(th_conso, NULL);
	pthread_join(th_prod, NULL);
	
}	// fin du main


void *produire(void *param) {		
		int m;
		for (m=0;m<5;m++) {	
			
			variable = variable + 5;
			printf("Production du message %d: %d\n", m, variable);
			
		}
			pthread_exit(NULL);

	}				// ------ Fin Producteur 

void *consommer(void *param) {	
		int m;
		for (m=0;m<5;m++){	
			
			printf("Consommation du message %d : %d\n", m, variable);
			
		}
			pthread_exit(NULL);
			
	}				// ------ Fin Consommateur 
