/*-------------------------------------------------------------------------------
 * TP 3 : Synchronisation par Smaphores Posix.
  
 * Protger l'accs  une variable partage par un smaphore d'exclusion mutuelle
 * -----------------------------------------------------------------------------------
 */

#include <stdio.h>           
#include <stdlib.h>           
#include <pthread.h>
#include <semaphore.h>

sem_t S; // declaration d'un semaphore

/* dclaration et initialisation de la variable partage */	
	int v = 10000;

void *incrementer(void *i);	// prototype de la fonction executee par le thread1
void *decrementer(void *i);	// prototype de la fonction executee par le thread2

int main(int argc, char *argv[])
{
	pthread_t th1, th2; // declaration de deux identificateurs de threads
    	int i, error;
	
	/* Initialisation du smaphore */
	i = sem_init(&S, 0, 1);
	if (i == -1) {
	printf ("Erreur : probleme lors de l'initialisation du semaphore\n");
		exit (1);
	}

	/* creation des threads */
	error = pthread_create(&th1, NULL, incrementer, NULL);
		if (error !=0) printf ("erreur lors de la creation de thread 1\n");
	error = pthread_create(&th2, NULL, decrementer, NULL);
		if (error !=0) printf ("erreur lors de la creation de thread 2\n");
	
/* attendre la fin des threads */	 
	pthread_join(th1, NULL);
	pthread_join(th2, NULL);
	
	printf("La valeur finale de v est %d\n",v);
}	// fin du main

void *incrementer(void *i) {
		int j;
		printf("Debut du Thread 1\n ");
		for (j = 0; j < 10000; j++){

			//Ajouter une instruction ici
			v++;
			//Ajouter une instruction ici
		}		

		printf("Fin du Thread 1\n");
		pthread_exit(NULL);
	}				

void *decrementer(void *i) {
		int j;
		printf("Debut du Thread 2\n ");
		for (j = 0; j < 10000; j++){

			// Ajoutez une instruction ici
			v--;
			// Ajoutez une instruction ici
		}
			
		printf("Fin du Thread 2\n");
		pthread_exit(NULL);
	}				
